/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.pb162.adding;

/**
 *
 * @author apple
 */
public interface Operand {
    /**
     * Pricte hodnotu value k hodnote objektu
     * @param value hodnota druheho operandu
     * @return soucet operandu s timto objektem.
     * @throws cz.muni.fi.pb162.adding.NumericException v pripade, ze nesouhlasi typy operandu
     *          vyvola se TypeMismatchException, pokud nesouhlasi dimenze vektoroveho prostoru 
     *          operandu, tak se vyvola InvalidDimensionException
     */
    Operand add(Operand value)throws NumericException;
    /**
     * Odecte hodnotu value od hodnoty objektu
     * @param value hodnota operandu
     * @return rozdil objektu a operandu
     * @throws cz.muni.fi.pb162.adding.NumericException v pripade, ze nesouhlasi typy operandu
     *          vyvola se TypeMismatchException, pokud nesouhlasi dimenze vektoroveho prostoru 
     *          operandu, tak se vyvola InvalidDimensionException
     */
    Operand sub(Operand value)throws NumericException;
}
