/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.pb162.adding;

/**
 *
 * @author apple
 */
public class Scalar implements Operand{
    
    private double value;

    public Scalar(double value) {
        this.value = value;
    }

    public double getValue() {
        return value;
    }

    public Operand add(Operand value) throws NumericException {
        Operand result;
        
        if ( value == null ) throw new IllegalArgumentException("Parametr value je null");
        if (! ( value instanceof Scalar )) 
           throw new TypeMismatchException("Nelze scitat scalar s vektorem");
        Scalar operand = (Scalar) value;
        result = new Scalar(this.value + operand.getValue());
        
        return result;
    }

    public Operand sub(Operand value) throws NumericException {
        Operand result;
        
        if ( value == null ) throw new IllegalArgumentException("Parametr value je null");
        if (! ( value instanceof Scalar )) 
           throw new TypeMismatchException("Nelze scitat scalar s vektorem");
        Scalar operand = (Scalar) value;
        result = new Scalar(this.value - operand.getValue());
        
        return result;
    }
    
}
